/******************************************************************************
globus_mp_mpi.c

Description:

  MPI activation

CVS Information:

  $Source: /home/globdev/CVS/globus-1998_04_16/Globus/Communication/mp/library/globus_mp_mpi.c,v $
  $Date: 1998/05/01 21:41:56 $
  $Revision: 1.1 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "globus_mp_mpi.h"


/******************************************************************************
			  Module activation structure
******************************************************************************/
static int
globus_l_mp_mpi_activate(void);

static int
globus_l_mp_mpi_deactivate(void);

static void
globus_l_mp_mpi_atexit(void);


globus_module_descriptor_t		globus_i_mp_mpi_module =
{
    "globus_mp_mpi",
    globus_l_mp_mpi_activate,
    globus_l_mp_mpi_deactivate,
    globus_l_mp_mpi_atexit
};


/******************************************************************************
			   MPI activation functions
******************************************************************************/
static int
globus_l_mp_mpi_activate(void)
{
    int					initialized;

    MPI_Initialized(&initialized);
    if (!initialized)
    {
	MPI_Init(NULL, NULL);
    }

    return GLOBUS_TRUE;
}


static int
globus_l_mp_mpi_deactivate(void)
{
    return GLOBUS_TRUE;
}


static void
globus_l_mp_mpi_atexit(void)
{
    int					initialized;

    MPI_Initialized(&initialized);
    if (initialized)
    {
	MPI_Finalize();
    }
}


