/******************************************************************************
CIF_Comm_Message.H

Description:

  Message buffer class

  Note: The message data buffer is completely exposed to the user.  Any
  modifications made to the data pointed to by get_Data() will permanently
  affect the data stored in the buffer.

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Comm_Message.H,v $
  $Date: 1998/09/25 15:08:35 $
  $Revision: 1.4 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

#if !defined(CIF_INCLUDE_COMM_MESSAGE)
#define CIF_INCLUDE_COMM_MESSAGE 1

/******************************************************************************
			       Type definitions
******************************************************************************/

/*
 * Buffer meta-data.  This will eventually contiain membershop information.
 */
struct CIF_Comm_Message_Info
{
    CIF_Size				size;
    int					tag;
};


/******************************************************************************
			       Class definition
******************************************************************************/
class
CIF_Comm_Message
{
    /**************************************************************************
				    API methods
    **************************************************************************/
    public:
    CIF_Comm_Message();

    public:
    CIF_Bool
    activate(
	ARG_IN const
	CIF_Comm_Message_Info &		info);

    public:
    CIF_Byte *
    get_Data();

    public:
    CIF_Comm_Message_Info
    get_Info();

    public:
    CIF_Bool
    deactivate();
    
    public:
    ~CIF_Comm_Message();


    /**************************************************************************
			       Private data members
    **************************************************************************/
    private:

    enum Object_State
    {
	OBJECT_STATE_INACTIVE,
	OBJECT_STATE_ACTIVE,
	OBJECT_STATE_DELETED
    };

    /* Message data buffer */
    CIF_Byte *				l_data;

    /* Message meta-data */
    CIF_Comm_Message_Info		l_info;

    /* object state */
    Object_State			l_object_state;
};

#endif
