/******************************************************************************
CIF_I_Comm_NSML_Monitor.C

Description:

  A simple monitor class built using nexus mutexes and condition variables

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Toolkit_Monitor.C,v $
  $Date: 1998/09/25 15:08:52 $
  $Revision: 1.2 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_Toolkit.H"


/******************************************************************************
		       Define CIF_Toolkit_Monitor class
******************************************************************************/

CIF_Toolkit_Monitor::CIF_Toolkit_Monitor(
    ARG_INMOD CIF_Toolkit_Mutex &		mutex)
: l_mutex(&mutex),
  l_cond((CIF_Toolkit_Cond *) CIF_NULL)
{
    l_mutex->lock();
}


CIF_Toolkit_Monitor::CIF_Toolkit_Monitor(
    ARG_INMOD CIF_Toolkit_Mutex &		mutex,	
    ARG_INMOD CIF_Toolkit_Cond &		cond)
: l_mutex(&mutex),
  l_cond(&cond)
{
    l_mutex->lock();
}


CIF_Toolkit_Monitor::~CIF_Toolkit_Monitor()
{
    l_mutex->unlock();
}


void
CIF_Toolkit_Monitor::wait(
    ARG_IN const CIF_Toolkit_Timeout &		timeout)
{
    globus_assert(l_cond != CIF_NULL);
    
    l_cond->wait(*l_mutex, timeout);
}


void
CIF_Toolkit_Monitor::signal()
{
    globus_assert(l_cond != CIF_NULL);
    
    l_cond->signal();
}


void
CIF_Toolkit_Monitor::broadcast()
{
    globus_assert(l_cond != CIF_NULL);
    
    l_cond->broadcast();
}
