/******************************************************************************
CIF_Toolkit_Timeout.C

Description:

  A simple timer class

CVS Information:

  $Source: /home/dsl/Master/cif/CIF-Comm-C++-Current/library/CIF_Toolkit_Timeout.C,v $
  $Date: 1998/09/25 15:08:54 $
  $Revision: 1.2 $
  $State: Exp $
  $Author: toonen $
******************************************************************************/

/******************************************************************************
			     Include header files
******************************************************************************/
#include "CIF_Toolkit.H"
#include <limits.h>
#include <sys/time.h>


/******************************************************************************
		     Class CIF_Toolkit_Timeout definition
******************************************************************************/

const int CIF_Toolkit_Timeout::INFINITY = INT_MAX;

CIF_Toolkit_Timeout::CIF_Toolkit_Timeout()
{
    l_reset(0);
}


CIF_Toolkit_Timeout::CIF_Toolkit_Timeout(
    const int					milliseconds)
{
    l_reset(milliseconds);
}


CIF_Toolkit_Timeout &
CIF_Toolkit_Timeout::operator =(
    const int					milliseconds)
{
    l_reset(milliseconds);
    return *this;
}


CIF_Toolkit_Timeout::operator int() const
{
    int						time_left;
    
    if (l_time_allotted == INT_MAX)
    {
	time_left = INT_MAX;
    }
    else
    {
	struct timeval				tv;
	
	gettimeofday(&tv, GLOBUS_NULL);
	time_left = l_time_allotted + l_time_started
	    - (tv.tv_sec * 1000 + tv.tv_usec / 1000);
	if (time_left < 0)
	{
	    time_left = 0;
	}
    }

    return time_left;
}


void
CIF_Toolkit_Timeout::l_reset(
    const int					milliseconds)
{
    l_time_allotted = milliseconds;
    
    if (l_time_allotted != INT_MAX)
    {
	struct timeval				tv;

	gettimeofday(&tv, GLOBUS_NULL);
	l_time_started = tv.tv_sec * 1000 + tv.tv_usec / 1000;
    }
}
